   MEMBER

!*******************************************************************************
! xFunction Library v2.8
! Copyright 2001-2010, SealSoft Company
!*******************************************************************************

   INCLUDE('equates.clw'),ONCE
   INCLUDE('errors.clw'),ONCE
   INCLUDE('keycodes.clw'),ONCE
   INCLUDE('winequ.cif'),ONCE
   INCLUDE('xfunc.inc','constants'),ONCE
   INCLUDE('xfunc.inc','CLASSES'),ONCE

   MAP
     MODULE('C runtime')
       xf_memcpy(LONG,LONG,LONG),NAME('_memcpy'),DLL(dll_mode)
     END
     MODULE('Windows API')
       xf_GetTempPath(LONG nBufferLength, *CSTRING lpBuffer),SIGNED,PASCAL,RAW,PROC,NAME('GetTempPathA')
       xf_VerQueryValue(LONG,LONG,LONG,LONG), ULONG,PASCAL,RAW,NAME('VerQueryValueA')
       xf_GetFileVersionInfo(*CSTRING,LONG,LONG,LONG), ULONG,PASCAL,RAW,NAME('GetFileVersionInfoA')
       xf_GetFileVersionInfoSize(*CSTRING,LONG), ULONG,PASCAL,RAW,NAME('GetFileVersionInfoSizeA')
       xf_GetFileAttributes(*CSTRING), ULONG,PASCAL,RAW,NAME('GetFileAttributesA')
       xf_SetFileAttributes(*CSTRING, ULONG),BYTE,PASCAL,RAW,NAME('SetFileAttributesA')
       xf_GlobalMemoryStatus(LONG),PASCAL,RAW,NAME('GlobalMemoryStatus')
       xf_BringWindowToTop(UShort),Byte,Pascal,NAME('BringWindowToTop')
       xf_Keybd_Event(BYTE bVk, BYTE bScan, DWORD dwFlags, DWORD dwExtraInfo),PASCAL,NAME('Keybd_Event')
       xf_CreateDirectory(*CSTRING,LONG),SIGNED,PASCAL,RAW,NAME('CreateDirectoryA')
       xf_FnSplit(*cstring,*cstring,*cstring,*cstring,*cstring),short,raw,name('_fnsplit')
       xf_GetLogicalDrives(),Long,PASCAL,Name('GetLogicalDrives')
       xf_GetDriveType(*cString),Long,Pascal,Raw,Name('GetDriveTypeA')
       xf_Access(*cstring,signed),signed,raw,name('_access')
       xf_SHBrowseForFolder(LONG lpbi),LONG,RAW,PASCAL,NAME('SHBrowseForFolder')
       xf_SHGetPathFromIDList(LONG pidl,LONG pszPath),BOOL,RAW,PASCAL,NAME('SHGetPathFromIDList')
       xf_SHGetSpecialFolderLocation(ULONG hwndOwner,LONG nFolder,*LONG ppidl),LONG,PASCAL,NAME('SHGetSpecialFolderLocation')
       xf_GetClientRect(LONG hwnd, *GROUP cRect),SIGNED,PROC,RAW,PASCAL,NAME('GetClientRect')
       xf_GetSystemMetrics(SIGNED),SIGNED,PASCAL,NAME('GetSystemMetrics')
       xf_GetWindow(ULONG H, LONG), ULONG, PROC, PASCAL, NAME('GetWindow')
       xf_GetClassName(ULONG,*CSTRING,SIGNED),SIGNED,PASCAL,RAW,NAME('GetClassNameA')
     END
     INCLUDE('xfunc.inc','prototypes'),ONCE
   END

!=======================================================================================================================
xf_SM_CYCAPTION                   EQUATE(4)
xf_SM_CXEDGE                      EQUATE(45)

xf_SM_CXBORDER                    EQUATE(5)
xf_SM_CYBORDER                    EQUATE(6)
xf_SM_CXDLGFRAME                  EQUATE(7)
xf_SM_CYDLGFRAME                  EQUATE(8)
xf_SM_CXFRAME                     EQUATE(32)
xf_SM_CYFRAME                     EQUATE(33)
xf_SM_CXMENUSIZE                  EQUATE(54)
xf_SM_CYMENUSIZE                  EQUATE(55)
xf_SM_CXFIXEDFRAME                EQUATE(xf_SM_CXDLGFRAME)
xf_SM_CYFIXEDFRAME                EQUATE(xf_SM_CYDLGFRAME)
xf_SM_CXSIZEFRAME                 EQUATE(xf_SM_CXFRAME)
xf_SM_CYSIZEFRAME                 EQUATE(xf_SM_CYFRAME)


TEMP:MY:FILE:Name                 STRING(256)
TEMP:MY:FILE                      FILE, DRIVER('ASCII'), NAME(TEMP:MY:FILE:Name), PRE(TMF), CREATE
Record                              RECORD,PRE()
Line                                  STRING(20000)
                                    END
                                  END

LOC:Path                          CSTRING(256)
LOC:Dir                           CSTRING(256)
LOC:Drive                         CSTRING(256)
LOC:File                          CSTRING(256)
LOC:Ext                           CSTRING(256)
GLO:Language                      BYTE(1)
ZodiacSignRus                     STRING(50),DIM(12)
ZodiacSignEng                     STRING(50),DIM(12)
ChineYearRus                      STRING(50),DIM(12)
ChineYearEng                      STRING(50),DIM(12)
EngMonth                          STRING(50),DIM(12)
EngDay                            STRING(50),DIM(7)
!==========================================================================================================================
! xInitLibrary    PROCEDURE
!==========================================================================================================================
xInitLibrary      PROCEDURE

  CODE
  EngMonth[1]       = 'January'
  EngMonth[2]       = 'February'
  EngMonth[3]       = 'March'
  EngMonth[4]       = 'April'
  EngMonth[5]       = 'May'
  EngMonth[6]       = 'June'
  EngMonth[7]       = 'Jule'
  EngMonth[8]       = 'August'
  EngMonth[9]       = 'September'
  EngMonth[10]      = 'October'
  EngMonth[11]      = 'November'
  EngMonth[12]      = 'December'

  EngDay[1]         = 'Monday'
  EngDay[2]         = 'Tuesday'
  EngDay[3]         = 'Wednesday'
  EngDay[4]         = 'Thursday'
  EngDay[5]         = 'Friday'
  EngDay[6]         = 'Saturday'
  EngDay[7]         = 'Sunday'

  ZodiacSignRus[1]  = ''
  ZodiacSignRus[2]  = ''
  ZodiacSignRus[3]  = ''
  ZodiacSignRus[4]  = ''
  ZodiacSignRus[5]  = ''
  ZodiacSignRus[6]  = ''
  ZodiacSignRus[7]  = ''
  ZodiacSignRus[8]  = ''
  ZodiacSignRus[9]  = ''
  ZodiacSignRus[10] = ''
  ZodiacSignRus[11] = ''
  ZodiacSignRus[12] = ''

  ZodiacSignEng[1]  = 'Aries'
  ZodiacSignEng[2]  = 'Taurus'
  ZodiacSignEng[3]  = 'Gemini'
  ZodiacSignEng[4]  = 'Cancer'
  ZodiacSignEng[5]  = 'Leo'
  ZodiacSignEng[6]  = 'Virgo'
  ZodiacSignEng[7]  = 'Libra'
  ZodiacSignEng[8]  = 'Scorpio'
  ZodiacSignEng[9]  = 'Sagittarius'
  ZodiacSignEng[10] = 'Capricorn'
  ZodiacSignEng[11] = 'Aquarius'
  ZodiacSignEng[12] = 'Pisces'

  ChineYearRus[1]   = ''
  ChineYearRus[2]   = ''
  ChineYearRus[3]   = ''
  ChineYearRus[4]   = ''
  ChineYearRus[5]   = ''
  ChineYearRus[6]   = ''
  ChineYearRus[7]   = ''
  ChineYearRus[8]   = ''
  ChineYearRus[9]   = ''
  ChineYearRus[10]  = ''
  ChineYearRus[11]  = ''
  ChineYearRus[12]  = ''

  ChineYearEng[1]   = 'Ox'
  ChineYearEng[2]   = 'Tiger'
  ChineYearEng[3]   = 'Cat'
  ChineYearEng[4]   = 'Dragon'
  ChineYearEng[5]   = 'Snake'
  ChineYearEng[6]   = 'Horse'
  ChineYearEng[7]   = 'Goat'
  ChineYearEng[8]   = 'Monkey'
  ChineYearEng[9]   = 'Rooster'
  ChineYearEng[10]  = 'Dog'
  ChineYearEng[11]  = 'Pig'
  ChineYearEng[12]  = 'Rat'

!=======================================================================================================================
! Date and Time Function
!=======================================================================================================================
! Age Calculate      PROCEDURE(LONG  Birthday), STRING
!=======================================================================================================================
xAgeCalculate        PROCEDURE(LONG Birthday)
Result               STRING(12)
ResultTemp           STRING(12)
LOC:Year             SHORT

  CODE
  Result = AGE(Birthday)
  CASE GLO:Language
  OF LANG:Rus
    IF INSTRING('D', Result)
      Result = CLIP(SUB(Result, 1, 2)) & ' .'
    ELSIF INSTRING('M', Result)
      Result = CLIP(SUB(Result, 1, 2)) & ' .'
    ELSIF INSTRING('R', Result)
      LOC:Year = Result[2]
      CASE LOC:Year
      OF 1
        ResultTemp = CLIP(SUB(Result, 1, 2)) & ' '
      OF 2 TO 4
        ResultTemp = CLIP(SUB(Result, 1, 2)) & ' '
      OF 5 TO 9 OROF 0
        ResultTemp = CLIP(SUB(Result, 1, 2)) & ' '
      END
      IF Result = 2 OR Result = 3 OR Result = 4
        ResultTemp = CLIP(SUB(Result, 1, 2)) & ' '
      END
      IF Result => 5 AND Result <= 20
        ResultTemp = CLIP(SUB(Result, 1, 2)) & ' '
      END
      Result = ResultTemp
    END
  OF LANG:Eng
    IF INSTRING('D', Result)
      Result = CLIP(SUB(Result, 1, 2)) & ' days'
    ELSIF INSTRING('M', Result)
      Result = CLIP(SUB(Result, 1, 2)) & ' months'
    ELSIF INSTRING('R', Result)
      LOC:Year = Result[2]
      CASE LOC:Year
      OF 1
        Result = CLIP(SUB(Result, 1, 2)) & ' years'
      OF 2 TO 4
        Result = CLIP(SUB(Result, 1, 2)) & ' years'
      OF 5 TO 9 OROF 0
        Result = CLIP(SUB(Result, 1, 2)) & ' years'
      END
      IF Result = 2 OR Result = 3 OR Result = 4
        Result = CLIP(SUB(Result, 1, 2)) & ' years'
      END
    END
  END
  RETURN Result


!=======================================================================================================================
! xGetZodiac            PROCEDURE(LONG  Birthday), STRING
!=======================================================================================================================
xGetZodiac              PROCEDURE(LONG  Birthday, *STRING ZodiacSign)
Result                  STRING(20)
Day                     BYTE
Month                   BYTE

  CODE
  Day   = DAY(Birthday)
  Month = MONTH(Birthday)
  IF (Month = 3 AND Day => 21) OR (Month = 4 AND Day <= 20)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[1]                      ! 
      ZodiacSign = ZodiacSignEng[1]                      ! Aries
    END
    RETURN 1
  END
  IF (Month = 4 AND Day => 21) OR (Month = 5 AND Day <= 20)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[2]                      ! 
      ZodiacSign = ZodiacSignEng[2]                      ! Taurus
    END
    RETURN 2
  END
  IF (Month = 5 AND Day => 21) OR (Month = 6 AND Day <= 21)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[3]                      ! 
      ZodiacSign = ZodiacSignEng[3]                      ! Gemini
    END
    RETURN 3
  END
  IF (Month = 6 AND Day => 22) OR (Month = 7 AND Day <= 22)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[4]                      ! 
      ZodiacSign = ZodiacSignEng[4]                      ! Cancer
    END
    RETURN 4
  END
  IF (Month = 7 AND Day => 23) OR (Month = 8 AND Day <= 23)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[5]                      ! 
      ZodiacSign = ZodiacSignEng[5]                      ! Leo
    END
    RETURN 5
  END
  IF (Month = 8 AND Day => 24) OR (Month = 9 AND Day <= 23)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[6]                      ! 
      ZodiacSign = ZodiacSignEng[6]                      ! Virgo
    END
    RETURN 6
  END
  IF (Month = 9 AND Day => 24) OR (Month = 10 AND Day <= 23)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[7]                      ! 
      ZodiacSign = ZodiacSignEng[7]                      ! Libra
    END
    RETURN 7
  END
  IF (Month = 10 AND Day => 24) OR (Month = 11 AND Day <= 22)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[8]                      ! 
      ZodiacSign = ZodiacSignEng[8]                      ! Scorpio
    END
    RETURN 8
  END
  IF (Month = 11 AND Day => 23) OR (Month = 12 AND Day <= 21)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[9]                      ! 
      ZodiacSign = ZodiacSignEng[9]                      ! Sagittarius
    END
    RETURN 9
  END
  IF (Month = 12 AND Day => 22) OR (Month = 1 AND Day <= 20)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[10]                      ! 
      ZodiacSign = ZodiacSignEng[10]                      ! Capricorn
    END
    RETURN 10
  END
  IF (Month = 1 AND Day => 21) OR (Month = 2 AND Day <= 20)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[11]                      ! 
      ZodiacSign = ZodiacSignEng[11]                      ! Aquarius
    END
    RETURN 11
  END
  IF (Month = 2 AND Day => 21) OR (Month = 3 AND Day <= 20)
    EXECUTE GLO:Language
      ZodiacSign = ZodiacSignRus[12]                      ! 
      ZodiacSign = ZodiacSignEng[12]                      ! Pisces
    END
    RETURN 12
  END

!=======================================================================================================================
! xGetChineYear         PROCEDURE(LONG  Year), STRING
!=======================================================================================================================
xGetChineYear           PROCEDURE(LONG  Year, *STRING ChineYear)

  CODE

  IF INLIST(Year, 1889, 1901, 1913, 1925, 1937, 1949, 1961, 1973, 1985, 1997, 2009, 2021)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[1]
      ChineYear = ChineYearEng[1]
    END
    RETURN 1
  END
  IF INLIST(Year, 1890, 1902, 1914, 1926, 1938, 1950, 1962, 1974, 1986, 1998, 2010, 2022)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[2]
      ChineYear = ChineYearEng[2]
    END
    RETURN 2
  END
  IF INLIST(Year, 1891, 1903, 1915, 1927, 1939, 1951, 1963, 1975, 1987, 1999, 2011, 2023)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[3]
      ChineYear = ChineYearEng[3]
    END
    RETURN 3
  END
  IF INLIST(Year, 1892, 1904, 1916, 1928, 1940, 1952, 1964, 1976, 1988, 2000, 2012, 2024)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[4]
      ChineYear = ChineYearEng[4]
    END
    RETURN 4
  END
  IF INLIST(Year, 1893, 1905, 1917, 1929, 1941, 1953, 1965, 1977, 1989, 2001, 2013, 2025)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[5]
      ChineYear = ChineYearEng[5]
    END
    RETURN 5
  END
  IF INLIST(Year, 1894, 1906, 1918, 1930, 1942, 1954, 1966, 1978, 1990, 2002, 2014, 2026)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[6]
      ChineYear = ChineYearEng[6]
    END
    RETURN 6
  END
  IF INLIST(Year, 1895, 1907, 1919, 1931, 1943, 1955, 1967, 1979, 1991, 2003, 2015, 2027)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[7]
      ChineYear = ChineYearEng[7]
    END
    RETURN 7
  END
  IF INLIST(Year, 1896, 1908, 1920, 1932, 1944, 1956, 1968, 1980, 1992, 2004, 2016, 2028)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[8]
      ChineYear = ChineYearEng[8]
    END
    RETURN 8
  END
  IF INLIST(Year, 1897, 1909, 1921, 1933, 1945, 1957, 1969, 1981, 1993, 2005, 2017, 2029)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[9]
      ChineYear = ChineYearEng[9]
    END
    RETURN 9
  END
  IF INLIST(Year, 1898, 1910, 1922, 1934, 1946, 1958, 1970, 1982, 1994, 2006, 2018, 2030)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[10]
      ChineYear = ChineYearEng[10]
    END
    RETURN 10
  END
  IF INLIST(Year, 1899, 1911, 1923, 1935, 1947, 1959, 1971, 1983, 1995, 2007, 2019, 2031)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[11]
      ChineYear = ChineYearEng[11]
    END
    RETURN 11
  END
  IF INLIST(Year, 1900, 1912, 1924, 1936, 1948, 1960, 1972, 1984, 1996, 2008, 2020, 2032)
    EXECUTE GLO:Language
      ChineYear = ChineYearRus[12]
      ChineYear = ChineYearEng[12]
    END
    RETURN 12
  END

!=======================================================================================================================
! xGetDayName       PROCEDURE(<LONG InpDate>, <BYTE NameType>), STRING
!=======================================================================================================================
xGetDayName         PROCEDURE(<LONG InpDate>, <BYTE NameType>)
DayNum              BYTE
DayName             STRING(11)

  CODE
  IF OMITTED(1)
    InpDate = TODAY()
  END
  IF OMITTED(2)
    NameType = 1
  END
  DayNum = InpDate % 7                         !  
  IF DayNum  = 0
    DayNum = 7
  END
  CASE GLO:Language
  OF LANG:Rus
    EXECUTE NameType
      RETURN CHOOSE(DayNum, '', '', '', '', '', '', '')
      RETURN CHOOSE(DayNum, '', '', '', '', '', '', '')
      RETURN CHOOSE(DayNum, '', '', '', '', '', '', '')
      RETURN CHOOSE(DayNum, ' ', ' ', ' ', ' ', ' ', ' ', ' ')
      RETURN CHOOSE(DayNum, '', '', '', '', '', '', '')
      RETURN CHOOSE(DayNum, '', '', '', '', '', '', '')
    END
  OF LANG:Eng
    EXECUTE DayNum
      DayName = CHOOSE(NameType, EngDay[1], SUB(EngDay[1],1,3), 'on ' & CLIP(EngDay[1]))
      DayName = CHOOSE(NameType, EngDay[2], SUB(EngDay[2],1,3), 'on ' & CLIP(EngDay[2]))
      DayName = CHOOSE(NameType, EngDay[3], SUB(EngDay[3],1,3), 'on ' & CLIP(EngDay[3]))
      DayName = CHOOSE(NameType, EngDay[4], SUB(EngDay[4],1,3), 'on ' & CLIP(EngDay[4]))
      DayName = CHOOSE(NameType, EngDay[5], SUB(EngDay[5],1,3), 'on ' & CLIP(EngDay[5]))
      DayName = CHOOSE(NameType, EngDay[6], SUB(EngDay[6],1,3), 'on ' & CLIP(EngDay[6]))
      DayName = CHOOSE(NameType, EngDay[7], SUB(EngDay[7],1,3), 'on ' & CLIP(EngDay[7]))
    END
    RETURN (CLIP(DayName))                                        ! Terminate Execute
  END

!=======================================================================================================================
! xGetDayNumber     PROCEDURE(<LONG InpDate>), BYTE
!=======================================================================================================================
xGetDayNumber       PROCEDURE(<LONG InpDate>)
DayNum              BYTE

  CODE
  IF OMITTED(1)                                                        !
    InpDate = TODAY()                                                  !
  END                                                                  ! If Date is omitted, use current date
  DayNum = InpDate % 7                                                 !  
  CASE GLO:Language
  OF LANG:Rus
    IF DayNum  = 0                                                       !
      DayNum = 7                                                         !
    END                                                                  !
  OF LANG:Eng
    DayNum += 1
  END
  RETURN DayNum                                                        ! What is the day of the week?

!=======================================================================================================================
! xLeapYear         ?
!=======================================================================================================================
xLeapYear          PROCEDURE(InDate)

  CODE
  IF OMITTED(1) THEN InDate = TODAY() END                             ! If Date is omitted, use current date

  IF INRANGE(InDate,4,109211)                                         ! If Valid Date
    CASE (DATE(12, 31, YEAR(InDate)) - DATE(1, 1, YEAR(InDate)) + 1)
    OF 365
      RETURN FALSE
    OF 366
      RETURN TRUE
    END
  ELSE                                                                ! If the date is not valid
    RETURN 2                                                          ! Return Error
  END                                                                 ! Terminate IF

!=======================================================================================================================
! xMonthOfYear          
!=======================================================================================================================
xMonthOfYear       PROCEDURE(<LONG InDate>, <BYTE Mode>)
Month         BYTE
MonthString   STRING(20)

  CODE
  IF OMITTED(1) THEN InDate = TODAY() END                             !    ,  
  IF OMITTED(2) THEN Mode   = 2 END                                   !    ,   

  CASE GLO:Language
  OF LANG:Rus
    IF INRANGE(InDate, 4, 109211)                                       ! If Valid Date
      MONTH = MONTH(InDate)                                             !  
      EXECUTE (MONTH)                                                   ! What is the day of the week?
        MonthString = CHOOSE(Mode, '', '', '')          ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')        ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')             ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')          ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')                ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')              ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')              ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')         ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')      ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')        ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')          ! If 1 Then Return 'Sunday'
        MonthString = CHOOSE(Mode, '', '', '')        ! If 1 Then Return 'Sunday'
      END
      RETURN CLIP(MonthString)                                          ! Terminate Execute
    ELSE                                                                ! If the date is not valid
      RETURN ''                                                   ! Return Error
    END                                                                 ! Terminate IF
  OF LANG:Eng
    IF INRANGE(InDate, 4, 109211)                                       ! If Valid Date
      MONTH = MONTH(InDate)                                             !  
      EXECUTE (MONTH)                                                   ! What is the day of the week?
        MonthString = CHOOSE(Mode, SUB(EngMonth[1],1,3), EngMonth[1],'in ' & CLIP(EngMonth[1]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[2],1,3), EngMonth[2],'in ' & CLIP(EngMonth[2]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[3],1,3), EngMonth[3],'in ' & CLIP(EngMonth[3]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[4],1,3), EngMonth[4],'in ' & CLIP(EngMonth[4]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[5],1,3), EngMonth[5],'in ' & CLIP(EngMonth[5]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[6],1,3), EngMonth[6],'in ' & CLIP(EngMonth[6]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[7],1,3), EngMonth[7],'in ' & CLIP(EngMonth[7]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[8],1,3), EngMonth[8],'in ' & CLIP(EngMonth[8]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[9],1,3), EngMonth[9],'in ' & CLIP(EngMonth[9]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[10],1,3), EngMonth[10],'in ' & CLIP(EngMonth[10]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[11],1,3), EngMonth[11],'in ' & CLIP(EngMonth[11]))
        MonthString = CHOOSE(Mode, SUB(EngMonth[12],1,3), EngMonth[12],'in ' & CLIP(EngMonth[12]))
      END
      RETURN CLIP(MonthString)                                          ! Terminate Execute
    ELSE                                                                ! If the date is not valid
      RETURN 'Error'                                                    ! Return Error
    END                                                                 ! Terminate IF
  END

!=======================================================================================================================
! xQuartOfYear        
!=======================================================================================================================
xQuartOfYear       PROCEDURE(<LONG InDate>)

  CODE
  IF OMITTED(1)
    InDate = TODAY()                                                  ! If Date is omitted, use current date
  END                                                                 !
  IF INRANGE(InDate,4,109211)                                         ! If Valid Date
    IF INRANGE(MONTH(InDate), 1, 3)   THEN RETURN 1 END
    IF INRANGE(MONTH(InDate), 4, 6)   THEN RETURN 2 END
    IF INRANGE(MONTH(InDate), 7, 9)   THEN RETURN 3 END
    IF INRANGE(MONTH(InDate), 10,12)  THEN RETURN 4 END
  ELSE                                                                ! If the date is not valid
    RETURN 0                                                          ! Return Error
  END                                                                 ! Terminate IF

!=======================================================================================================================
! xWeekOfYear             (1-52/53)
!=======================================================================================================================
xWeekOfYear          PROCEDURE(<LONG InDate>)
WeekNum              BYTE

  CODE
  IF OMITTED(1)
    InDate = TODAY()
  END                                                                  ! If Date is omitted, use current date
  WeekNum = INT((InDate-1)/7)-INT((DATE(1,1,YEAR(InDate))-1)/7) + 1
  RETURN WeekNum

!=======================================================================================================================
! xWeekOfMonth            ( 1-5( ))
!=======================================================================================================================
xWeekOfMonth         PROCEDURE(<LONG InDate>)
WeekNum              BYTE

  CODE
  IF OMITTED(1)
    InDate = TODAY()
  END
  WeekNum = xWeekOfYear(InDate)-xWeekOfYear(DATE(MONTH(InDate), 1, YEAR(InDate)))+1
  RETURN WeekNum

!=======================================================================================================================
! xIsLastDayOfMonth    ,      
!=======================================================================================================================
xIsLastDayOfMonth       PROCEDURE(<LONG InDate>)

  CODE
  IF OMITTED(1) THEN InDate = TODAY() END                                ! If Date is omitted, use current date

  IF INRANGE(InDate,4,109211)                                            ! If Valid Date
    IF MONTH(InDate) = MONTH(InDate+1)
      RETURN FALSE
    ELSE
      RETURN TRUE
    END
  ELSE                                                                   ! If the date is not valid
    RETURN 2                                                             ! Return Error
  END                                                                    ! Terminate IF

!=======================================================================================================================
! xLastDayOfMonth       PROCEDURE(<LONG InDate>), LONG                       
!=======================================================================================================================
xLastDayOfMonth         PROCEDURE(<LONG InDate>)

  CODE
  IF OMITTED(1)                                                         ! If InDate omitted
    InDate = TODAY()                                                    ! Use current date
  END                                                                   !
  IF INRANGE(InDate, 4, 109211)                                         ! If Valid Date
    RETURN DATE(MONTH(InDate)+1, 1, YEAR(InDate)) - 1
  ELSE                                                                  ! If the date is not valid
    RETURN 2                                                            ! Return Error
  END                                                                   ! Terminate IF
  RETURN FALSE

!=======================================================================================================================
! xDayOfYear            PROCEDURE(<LONG InDate>), SHORT                      
!=======================================================================================================================
xDayOfYear              PROCEDURE(<LONG InDate>)

  CODE
  IF OMITTED(1)                                                         ! If InDate omitted
    InDate = TODAY()                                                    ! Use current date
  END                                                                   !
                                                                        !
  IF INRANGE(InDate, 4, 109211)                                         ! If Valid Date
    RETURN InDate - DATE(1, 1, YEAR(InDate)) + 1                        !
  ELSE                                                                  ! If the date is not valid
    RETURN FALSE                                                        ! Return Error
  END                                                                      ! Terminate IF

!=======================================================================================================================
! xDaysLeftInYear       PROCEDURE(<LONG InDate>), SHORT                       
!=======================================================================================================================
xDaysLeftInYear         PROCEDURE(<LONG InDate>)

  CODE
  IF OMITTED(1)                                                         ! If InDate omitted
    InDate = TODAY()                                                    ! Use current date
  END                                                                   !

  IF INRANGE(InDate, 4, 109211)                                         ! If Valid Date
    RETURN DATE(12, 31, YEAR(InDate)) - InDate
  ELSE                                                                  ! If the date is not valid
    RETURN FALSE                                                        ! Return Error
  END                                                                   ! Terminate IF


!=======================================================================================================================
! xSetPeriodLastWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)      !    .  
!=======================================================================================================================
xSetPeriodLastWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
WorkDate                LONG
WorkDay                 LONG
WorkYear                LONG
WorkMonth               LONG
WorkDOW                 LONG
  CODE
  WorkDate  = TODAY()
  WorkMonth = MONTH(WorkDate)
  WorkYear  = YEAR(WorkDate)
  WorkDay   = DAY(WorkDate)
  WorkDOW   = WorkDate % 7
  Lowdate   = (WorkDate - WorkDOW) - 6
  Highdate  = Lowdate + 6

!=======================================================================================================================
! xSetPeriodCurrWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)      !    .  
!=======================================================================================================================
xSetPeriodCurrWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
WorkDate                LONG
WorkDay                 LONG
WorkYear                LONG
WorkMonth               LONG
WorkDOW                 LONG
  CODE
  WorkDate  = TODAY()
  WorkMonth = MONTH(WorkDate)
  WorkYear  = YEAR(WorkDate)
  WorkDay   = DAY(WorkDate)
  WorkDOW   = WorkDate % 7
  Lowdate   = (WorkDate - WorkDOW) + 1
  Highdate  = Lowdate + 6

!=======================================================================================================================
! xSetPeriodNextWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)      !    .  
!=======================================================================================================================
xSetPeriodNextWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
WorkDate                LONG
WorkDay                 LONG
WorkYear                LONG
WorkMonth               LONG
WorkDOW                 LONG
  CODE
  WorkDate  = TODAY()
  WorkMonth = MONTH(WorkDate)
  WorkYear  = YEAR(WorkDate)
  WorkDay   = DAY(WorkDate)
  WorkDOW   = WorkDate % 7
  Lowdate   = (WorkDate - WorkDOW) + 8
  Highdate  = Lowdate + 6

!=======================================================================================================================
! xSetPeriodLastMonth   PROCEDURE(*LONG LowDate, *LONG HighDate)        !    .  
!=======================================================================================================================
xSetPeriodLastMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)
LOC:Month               BYTE
LOC:Year                LONG

  CODE
  LOC:Month = MONTH(TODAY())
  LOC:Year  = YEAR(TODAY())
  IF LOC:Month = 1
    LOC:Month  = 12
    LOC:Year  -= 1
  ELSE
    LOC:Month -= 1
  END
  LowDate  = DATE(LOC:Month, 1,                             LOC:Year)
  HighDate = DATE(LOC:Month, DAY(xLastDayOfMonth(LowDate)), LOC:Year)

!=======================================================================================================================
! xSetPeriodCurrMonth   PROCEDURE(*LONG LowDate, *LONG HighDate)        !    .  
!=======================================================================================================================
xSetPeriodCurrMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)

  CODE
  LowDate  = DATE(MONTH(TODAY()), 1,                       YEAR(TODAY()))
  HighDate = DATE(MONTH(TODAY()), DAY(xLastDayOfMonth()) , YEAR(TODAY()))

!=======================================================================================================================
! xSetPeriodNextMonth   PROCEDURE(*LONG LowDate, *LONG HighDate)        !    .  
!=======================================================================================================================
xSetPeriodNextMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)
LOC:Month               BYTE
LOC:Year                LONG

  CODE
  LOC:Month = MONTH(TODAY())
  LOC:Year  = YEAR(TODAY())
  IF LOC:Month = 12
    LOC:Month  = 1
    LOC:Year  += 1
  ELSE
    LOC:Month += 1
  END
  LowDate  = DATE(LOC:Month, 1,                             LOC:Year)
  HighDate = DATE(LOC:Month, DAY(xLastDayOfMonth(LowDate)), LOC:Year)

!=======================================================================================================================
! xSetPeriodLastQuart   PROCEDURE(*LONG LowDate, *LONG HighDate)        !    .  
!=======================================================================================================================
xSetPeriodLastQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
LOC:Quart               BYTE
LOC:Month               BYTE
LOC:Year                LONG

  CODE
  LOC:Quart = xQuartOfYear()
  LOC:Year  = YEAR(TODAY())
  IF LOC:Quart = 1
    LOC:Quart  = 4
    LOC:Year  -= 1
  ELSE
    LOC:Quart -= 1
  END

  CASE LOC:Quart
  OF 1
    LowDate  = DATE(1,  1, LOC:Year)
    HighDate = DATE(3, 31, LOC:Year)
  OF 2
    LowDate  = DATE(4,  1, LOC:Year)
    HighDate = DATE(6, 30, LOC:Year)
  OF 3
    LowDate  = DATE(7,  1, LOC:Year)
    HighDate = DATE(9, 30, LOC:Year)
  OF 4
    LowDate  = DATE(10,  1, LOC:Year)
    HighDate = DATE(12, 31, LOC:Year)
  END

!=======================================================================================================================
! xSetPeriodCurrQuart   PROCEDURE(*LONG LowDate, *LONG HighDate)        !    .  
!=======================================================================================================================
xSetPeriodCurrQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
LOC:Quart               BYTE
LOC:Month               BYTE
LOC:Year                LONG

  CODE
  LOC:Quart = xQuartOfYear()
  LOC:Year  = YEAR(TODAY())
  CASE LOC:Quart
  OF 1
    LowDate  = DATE(1,  1, LOC:Year)
    HighDate = DATE(3, 31, LOC:Year)
  OF 2
    LowDate  = DATE(4,  1, LOC:Year)
    HighDate = DATE(6, 30, LOC:Year)
  OF 3
    LowDate  = DATE(7,  1, LOC:Year)
    HighDate = DATE(9, 30, LOC:Year)
  OF 4
    LowDate  = DATE(10,  1, LOC:Year)
    HighDate = DATE(12, 31, LOC:Year)
  END

!=======================================================================================================================
! xSetPeriodNextQuart   PROCEDURE(*LONG LowDate, *LONG HighDate)      !    .  
!=======================================================================================================================
xSetPeriodNextQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
LOC:Quart               BYTE
LOC:Month               BYTE
LOC:Year                LONG

  CODE
  LOC:Quart = xQuartOfYear()
  LOC:Year  = YEAR(TODAY())
  IF LOC:Quart = 4
    LOC:Quart  = 1
    LOC:Year  += 1
  ELSE
    LOC:Quart += 1
  END

  CASE LOC:Quart
  OF 1
    LowDate  = DATE(1,  1, LOC:Year)
    HighDate = DATE(3, 31, LOC:Year)
  OF 2
    LowDate  = DATE(4,  1, LOC:Year)
    HighDate = DATE(6, 30, LOC:Year)
  OF 3
    LowDate  = DATE(7,  1, LOC:Year)
    HighDate = DATE(9, 30, LOC:Year)
  OF 4
    LowDate  = DATE(10,  1, LOC:Year)
    HighDate = DATE(12, 31, LOC:Year)
  END

!==========================================================================================================================
! xSetEngMonth          PROCEDURE(BYTE Mon, STRING MonthName)
!=========================================================================================================================
xSetEngMonth            PROCEDURE(BYTE Mon, STRING MonthName)

  CODE
  EngMonth[Mon] = MonthName

!==========================================================================================================================
! xSetEngDay            PROCEDURE(BYTE Day, STRING DayName)
!==========================================================================================================================
xSetEngDay              PROCEDURE(BYTE Day, STRING DayName)

  CODE
  EngDay[Day] = DayName

!==========================================================================================================================
! xSetRusZodiac         PROCEDURE(BYTE SignNum, STRING SignName)
!==========================================================================================================================
xSetRusZodiac           PROCEDURE(BYTE SignNum, STRING SignName)

  CODE
  ZodiacSignRus[SignNum] = SignName

!==========================================================================================================================
! xSetEngZodiac         PROCEDURE(BYTE SignNum, STRING SignName)
!==========================================================================================================================
xSetEngZodiac           PROCEDURE(BYTE SignNum, STRING SignName)

  CODE
  ZodiacSignEng[SignNum] = SignName

!==========================================================================================================================
! xSetRusChineYear      PROCEDURE(BYTE SignNum, STRING SignName)
!==========================================================================================================================
xSetRusChineYear        PROCEDURE(BYTE SignNum, STRING SignName)

  CODE
  ChineYearRus[SignNum] = SignName

!==========================================================================================================================
! xSetEngChineYear      PROCEDURE(BYTE SignNum, STRING SignName)
!==========================================================================================================================
xSetEngChineYear        PROCEDURE(BYTE SignNum, STRING SignName)

  CODE
  ChineYearEng[SignNum] = SignName

!=======================================================================================================================
! File and path function
!=======================================================================================================================
! xCheckForSubfolders   PROCEDURE(STRING ParentDirectory), BYTE         
!=======================================================================================================================
xCheckForSubfolders     PROCEDURE(STRING ParentDirectory)
AllFiles                QUEUE(FILE:Queue),PRE(FIL)
                        END
  CODE
  FREE(AllFiles)
  DIRECTORY(AllFiles, CLIP(ParentDirectory) & '\*.*', ff_:DIRECTORY)
  LOOP i# = 1 TO RECORDS(AllFiles)
    GET(AllFiles,i#)
    IF BAND(FIL:Attrib, ff_:DIRECTORY) AND FIL:ShortName <> '..' AND FIL:ShortName <> '.'
      FREE(AllFiles)
      RETURN TRUE
    END
  END
  FREE(AllFiles)
  RETURN FALSE

!==========================================================================================================================
! xCopyFile             PROCEDURE(STRING PassedSource, STRING PassedTarget), BYTE    
!==========================================================================================================================
xCopyFile               PROCEDURE(STRING PassedSource, STRING PassedTarget)
TargetFile              STRING(256)

  CODE
  TEMP:MY:FILE:Name = PassedSource
  TargetFile = Passedtarget
  COPY(TEMP:MY:FILE,TargetFile)
  IF ERRORCODE() THEN RETURN ERRORCODE() END
  RETURN 0

!==========================================================================================================================
! xMoveFile             PROCEDURE(STRING PassedSource, STRING PassedTarget), BYTE    
!==========================================================================================================================
xMoveFile               PROCEDURE(STRING PassedSource, STRING PassedTarget)
SourceFile              STRING(256)
TargetFile              STRING(256)

  CODE
  IF ~xCopyFile(SourceFile, TargetFile)
    IF xDeleteFile(SourceFile)
      RETURN ERRORCODE()
    END
  ELSE
    RETURN ERRORCODE()
  END
  RETURN 0

!=======================================================================================================================
! xCreateDir            PROCEDURE(STRING InPath), BYTE          
!=======================================================================================================================
xCreateDir              PROCEDURE(STRING InPath)
LOC:CSTRING             CSTRING(256)
NULL                    EQUATE(0)

  CODE
  LOC:CSTRING = CLIP(InPath)
  RETURN xf_CreateDirectory(LOC:CSTRING, NULL)

!=======================================================================================================================
! xCreateTreeDir        PROCEDURE(STRING Tree), BYTE             
!=======================================================================================================================
xCreateTreeDir          PROCEDURE(STRING Tree)
A                       BYTE
B                       STRING(256)
C                       STRING(256)
D                       STRING(256)

  CODE
  B = xNormDir(CLIP(Tree))
  C = B
  B[3] = ' '
  LOOP
    A = INSTRING('\',B,1,1)
    IF A = 0 THEN BREAK.
    D = SUB(C,1,A)
    B[A] = ' '
    IF xCreateDir(D)
    END
  END
  IF xPathExists(Tree)
    RETURN TRUE
  ELSE
    RETURN FALSE
  END

!==========================================================================================================================
! xDeleteFile           PROCEDURE(STRING PassedFile), BYTE      
!==========================================================================================================================
xDeleteFile             PROCEDURE(STRING PassedFile)

  CODE
  REMOVE(PassedFile)
  RETURN ERRORCODE()

!=======================================================================================================================
! xNormDir              PROCEDURE(STRING InPath), STRING             
!=======================================================================================================================
xNormDir                PROCEDURE(STRING InPath)

  CODE
  IF SUB(CLIP(InPath),-1,1) = '\'
    RETURN CLIP(InPath)
  ELSE
    RETURN CLIP(InPath) & '\'
  END

!=======================================================================================================================
! xDeNormDir            PROCEDURE(STRING InPath), STRING            
!=======================================================================================================================
xDeNormDir              PROCEDURE(STRING InPath)

  CODE
  IF SUB(CLIP(InPath),-1,1) = '\'
    RETURN CLIP(SUB(InPath,1,xLenStr(InPath)-1))
  ELSE
    RETURN CLIP(InPath)
  END

!=======================================================================================================================
! xExtractExt           PROCEDURE(STRING INP:Path), STRING          
!=======================================================================================================================
xExtractExt             PROCEDURE(STRING INP:Path)

  CODE
  LOC:Path = INP:Path
  IF xf_FnSplit(LOC:Path, LOC:Drive, LOC:Dir, LOC:File, LOC:Ext) END
  RETURN CLIP(SUB(LOC:Ext, 2, 256))

!=======================================================================================================================
! xExtractFile          PROCEDURE(STRING INP:Path), STRING            
!=======================================================================================================================
xExtractFile            PROCEDURE(STRING INP:Path)

  CODE
  LOC:Path = INP:Path
  IF xf_FnSplit(LOC:Path, LOC:Drive, LOC:Dir, LOC:File, LOC:Ext) END
  RETURN CLIP(LOC:File) & CLIP(LOC:Ext)

!=======================================================================================================================
! xExtractFileName      PROCEDURE(STRING INP:Path), STRING          
!=======================================================================================================================
xExtractFileName        PROCEDURE(STRING INP:Path)

  CODE
  LOC:Path = INP:Path
  IF xf_FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext) END
  RETURN CLIP(LOC:File)

!=======================================================================================================================
! xExtractPath          PROCEDURE(STRING Inp:Path), STRING           
!=======================================================================================================================
xExtractPath            PROCEDURE(STRING INP:Path)

  CODE
  LOC:Path = INP:Path
  IF xf_FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext) END
  RETURN xNormDir(CLIP(LOC:Drive) & CLIP(LOC:Dir))

!=======================================================================================================================
! xFindFile             PROCEDURE(STRING PassedFile), BYTE      
!=======================================================================================================================
xFindFile               PROCEDURE(STRING PassedFile)
FIQ                     QUEUE,PRE(F_IQ)
Name                      STRING(FILE:MAXFILENAME)
ShortName                 STRING(13)
Date                      LONG
Time                      LONG
Size                      LONG
Attrib                    BYTE
                        END
LOC:PassedFile          CSTRING(4)
  CODE
  IF (LEN(CLIP(PassedFile)) = 2 OR LEN(CLIP(PassedFile)) = 3) AND PassedFile[2] = ':'
    LOC:PassedFile = xDenormDir(PassedFile)
    IF xf_Access(LOC:PassedFile, 0)
      RETURN FALSE
    ELSE
      RETURN TRUE
    END
  ELSE
    DIRECTORY(FIQ, PassedFile, FF_:DIRECTORY)
    IF RECORDS(FIQ)
      RETURN TRUE
    END
  END
  RETURN FALSE

!=======================================================================================================================
! xGetFileAttr       PROCEDURE(STRING PassFile, LONG Attr), BYTE     
!=======================================================================================================================
xGetFileAttr         PROCEDURE(STRING PassFile, LONG Attr)
LOC:CSTRING          CSTRING(256)
LOC:ATTR             ULONG

  CODE
  LOC:CSTRING = PassFile
  LOC:ATTR = Attr
  IF BAND(xf_GetFileAttributes(LOC:CSTRING), LOC:ATTR)
    RETURN TRUE
  END
  RETURN FALSE

!=======================================================================================================================
! xSetFileAttr       PROCEDURE(STRING PassFile, LONG Attr), BYTE     
!=======================================================================================================================
xSetFileAttr         PROCEDURE(STRING PassFile, LONG Attr)
LOC:CSTRING          CSTRING(256)
LOC:ATTR             ULONG

  CODE
  LOC:CSTRING = PassFile
  LOC:ATTR = Attr
  IF xf_SetFileAttributes(LOC:CSTRING, LOC:ATTR)
    RETURN TRUE
  END
  RETURN FALSE

!=======================================================================================================================
! xPathExists        PROCEDURE(STRING INP:Path), BYTE                
!=======================================================================================================================
xPathExists          PROCEDURE(STRING INP:Path)
LOC:PathOld          STRING(256)

  CODE
  LOC:PathOld = PATH()
  SETPATH(INP:Path)
  IF ERRORCODE() = 03
    SETPATH(LOC:PathOld)
    RETURN FALSE
  ELSE
    SETPATH(LOC:PathOld)
  END
  RETURN TRUE

!=======================================================================================================================
! xRemovePathFromFileName PROCEDURE(*STRING FileName1, *STRING Path), STRING       
!=======================================================================================================================
xRemovePathFromFileName   PROCEDURE(*STRING FileName1, *STRING Path)
LOC:TempCString           CSTRING(256)

  CODE
  LOC:TempCString = CLIP(UPPER(xNormDir(Path)))
  IF INSTRING(CLIP(LOC:TempCString), UPPER(LEFT(FileName1)), 1, 1) = 1
    RETURN SUB(FileName1, LEN(CLIP(LEFT(LOC:TempCString))) + 1, 256)
  END
  RETURN FileName1

!=======================================================================================================================
! xGetRelativePath        PROCEDURE(STRING FileName1), STRING      /
!=======================================================================================================================
xGetRelativePath          PROCEDURE(STRING FileName1)

  CODE
  IF INSTRING(UPPER(LONGPATH()), UPPER(FileName1), 1 , 1) = 1
    FileName1 = '.' & SUB(FileName1, LEN(CLIP(LONGPATH()))+1, 256)
  END
  RETURN FileName1

!==========================================================================================================================
! xGetDrivers             PROCEDURE(*DriversQueue Drv)                     
!==========================================================================================================================
xGetDrivers               PROCEDURE(*DriversQueue Drv)
DRV:Disk                  CSTRING(10)

  CODE
  Q# = xf_GetLogicalDrives()
  I# = 65
  J# = 0
  Z# = 0
  LOOP WHILE Q#
    IF BAND(Q#, 1 )
      J# += 1
      DRV:Disk = CHR(I#) & ':\'
      W# = xf_GetDriveType(DRV:Disk)
      Drv.DriveChar = CHR(I#)
      Drv.DriveType = W#
      ADD(Drv)
    END
    Q# = BSHIFT(Q#, -1)
    I# += 1
  END

!==========================================================================================================================
! xGetFileSize            PROCEDURE(STRING FileName), LONG          
!==========================================================================================================================
xGetFileSize            PROCEDURE(STRING FileNamez)!,LONG
FIQ                     QUEUE,PRE(F_IQ)
Name                      STRING(FILE:MAXFILENAME)
ShortName                 STRING(13)
Date                      LONG
Time                      LONG
Size                      LONG
Attrib                    BYTE
                        END
  CODE
  DIRECTORY(FIQ, FileNamez, FF_:DIRECTORY)
  IF RECORDS(FIQ)
    GET(FIQ,1)
    RETURN FIQ.Size
  END
  RETURN -1

!==========================================================================================================================
! xGetTempPath         PROCEDURE(),STRING           Windows
!==========================================================================================================================
xGetTempPath           PROCEDURE()
LOC:Result             CSTRING(255)
  CODE
  xf_GetTempPath(SIZE(LOC:Result),LOC:Result)
  RETURN LOC:Result
!=======================================================================================================================
! xGetFileDate         PROCEDURE(STRING PassedFile, *LONG FDate, *LONG FTime),BYTE        
!=======================================================================================================================
xGetFileDate            PROCEDURE(STRING PassedFile, *LONG FDate, *LONG FTime)
FIQ                     QUEUE,PRE(F_IQ)
Name                      STRING(FILE:MAXFILENAME)
ShortName                 STRING(13)
Date                      LONG
Time                      LONG
Size                      LONG
Attrib                    BYTE
                        END
LOC:PassedFile          CSTRING(4)
  CODE
  DIRECTORY(FIQ, PassedFile, FF_:DIRECTORY)
  IF RECORDS(FIQ)
    GET(FIQ,1)
    IF ~ERRORCODE()
      FDate = FIQ.Date
      FTime = FIQ.Time
      RETURN TRUE
    END
    RETURN FALSE
  END
  RETURN FALSE
!=======================================================================================================================
! Misc function
!==========================================================================================================================
! xGenGlobalID         PROCEDURE(), STRING               
!==========================================================================================================================
xGenGlobalID           PROCEDURE()
GlobalID               STRING(20)

  CODE
  LOOP i# = 1 to 20
    EXECUTE RANDOM(1,3)
      GlobalID[i#] = CHR(RANDOM(48,57))
      GlobalID[i#] = CHR(RANDOM(65,90))
      GlobalID[i#] = CHR(RANDOM(97,122))
    END
  END
  RETURN GlobalID

!=======================================================================================================================
! xGetUniqCode       PROCEDURE(FILE F_File, KEY K_Key, *LONG V_Var), LONG          
!=======================================================================================================================
xGetUniqCode         PROCEDURE(FILE F_File, KEY K_Key, *LONG V_Var)
LOC:Code             LONG

  CODE
  CLEAR(V_Var,1)
  SET(K_Key,K_Key)
  PREVIOUS(F_File)
  IF ERRORCODE()
    LOC:Code = 1
  ELSE
    LOC:Code = V_Var + 1
  END
  RETURN LOC:Code

!=======================================================================================================================
! xGetConfig         PROCEDURE(FILE FilesName), BYTE, PROC        
!=======================================================================================================================
xGetConfig           PROCEDURE(FILE FilesName)

  CODE
  SET(FilesName, 1)
  NEXT(FilesName)
  IF ERRORCODE()
    MESSAGE('   : ' & CLIP(FilesName{PROP:Name}), '',ICON:Exclamation)
  END
  RETURN ERRORCODE()

!=======================================================================================================================
! xPutConfig          PROCEDURE(FILE FilesName), BYTE, PROC       
!=======================================================================================================================
xPutConfig            PROCEDURE(FILE FilesName)

  CODE
  PUT(FilesName)
  IF ERRORCODE()
    MESSAGE('   : ' & CLIP(FilesName{PROP:Name}), '',ICON:Exclamation)
  END
  RETURN ERRORCODE()

!=======================================================================================================================
! xOpenFolder          PROCEDURE(STRING OpenPath)               Explore
!=======================================================================================================================
xOpenFolder            PROCEDURE(STRING OpenPath)

  CODE
  RUN('EXPLORER.EXE '&OpenPath)
  IF RUNCODE() = -4
    MESSAGE(ERROR())
  END

!=======================================================================================================================
! xSetLanguage         PROCEDURE(BYTE Language)               
!=======================================================================================================================
xSetLanguage           PROCEDURE(BYTE Language)

  CODE
  GLO:Language = Language

!=======================================================================================================================
! xGetFileVersion         PROCEDURE(STRING FFileName),STRING   
!=======================================================================================================================
xGetFileVersion         PROCEDURE(STRING FFileName)
LOC:FileName            CSTRING(256)
Result                  STRING(255)
lpData                  CSTRING(32768)
lpSize                  LONG,AUTO
pSize                   LONG
pInfo                   LONG
pName                   CSTRING(256)
XF_FIXEDFILEINFO        GROUP,TYPE
dwSignature               LONG
dwStrucVersion            LONG
dwFileVersionMS           LONG
dwFileVersionLS           LONG
dwProductVersionMS        LONG
dwProductVersionLS        LONG
dwFileFlagsMask           LONG
dwFileFlags               LONG
dwFileOS                  LONG
dwFileType                LONG
dwFileSubtype             LONG
dwFileDateMS              LONG
dwFileDateLS              LONG
                        END
FI                      LIKE(XF_FIXEDFILEINFO)
  CODE
  LOC:FileName = FFileName
  lpSize = xf_GetFileVersionInfoSize(LOC:FileName, 0)
  IF lpSize
    IF xf_GetFileVersionInfo(LOC:FileName, 0, lpSize, ADDRESS(lpData))
      pName = '\'
      Err# = xf_VerQueryValue(ADDRESS(lpData), ADDRESS(pName), ADDRESS(pInfo), ADDRESS(pSize))
      xf_memcpy(ADDRESS(FI), pInfo , pSize)
      Result = BSHIFT(FI.dwFileVersionMS,-16)&'.'&BAND(FI.dwFileVersionMS,0FFFFh)&'.'&BSHIFT(FI.dwFileVersionLS,-16)&'.'&BAND(FI.dwFileVersionLS,0FFFFh)
    END
  END
  RETURN Result
!=======================================================================================================================
! Extended standard function
!=======================================================================================================================
! xReplace             PROCEDURE(*STRING pText,STRING Find,STRING Replace)      
!=======================================================================================================================
xReplace               PROCEDURE(*STRING pText,STRING Find,STRING Replace)
Locate                 LONG,AUTO
StartFrom              LONG,AUTO
  CODE
  StartFrom = 1
  LOOP
    Locate = INSTRING(UPPER(Find),UPPER(pText),1,StartFrom)
    IF ~Locate
      RETURN
    END
    pText = SUB(pText,1,Locate-1) & Replace & SUB(pText,Locate+LEN(Find),LEN(pText))
    StartFrom = Locate + LEN(Replace)
  END
!=======================================================================================================================
! xReplace             PROCEDURE(*CSTRING pText,STRING Find,STRING Replace)      
!=======================================================================================================================
xReplace               PROCEDURE(*CSTRING pText,STRING Find,STRING Replace)
Locate                 LONG,AUTO
StartFrom              LONG,AUTO
  CODE
  StartFrom = 1
  LOOP
    Locate = INSTRING(UPPER(Find),UPPER(pText),1,StartFrom)
    IF ~Locate
      RETURN
    END
    pText = SUB(pText,1,Locate-1) & Replace & SUB(pText,Locate+LEN(Find),LEN(pText))
    StartFrom = Locate + LEN(Replace)
  END
!=======================================================================================================================
! xQuote                  PROCEDURE(STRING Into),STRING        '  ''
!=======================================================================================================================
xQuote                 PROCEDURE(STRING Into)!,STRING
LOC:String             STRING(1024),AUTO
  CODE
  LOC:String = Into
  xReplace(LOC:String,'''','''''')
  RETURN CLIP(LOC:String)
!=======================================================================================================================
! xDelay               PROCEDURE(ULONG Delay)                  .
!=======================================================================================================================
xDelay                 PROCEDURE(ULONG Delay)
DelayTime              ULONG

  CODE
  DelayTime = CLOCK() + Delay
  LOOP WHILE CLOCK() <= DelayTime
    YIELD
  END

!=======================================================================================================================
! xHex                 PROCEDURE(BYTE FirstParam), STRING        HEX
!=======================================================================================================================
xHex                   PROCEDURE(BYTE FirstParam)
ByteToConvert          BYTE
ReturnString           STRING(2)

  CODE
  ReturnString = '00'
  ByteToConvert = FirstParam
  EXECUTE ByteToConvert/16
    ReturnString[1] = '1'
    ReturnString[1] = '2'
    ReturnString[1] = '3'
    ReturnString[1] = '4'
    ReturnString[1] = '5'
    ReturnString[1] = '6'
    ReturnString[1] = '7'
    ReturnString[1] = '8'
    ReturnString[1] = '9'
    ReturnString[1] = 'A'
    ReturnString[1] = 'B'
    ReturnString[1] = 'C'
    ReturnString[1] = 'D'
    ReturnString[1] = 'E'
    ReturnString[1] = 'F'
  END
  EXECUTE ByteToConvert % 16
    ReturnString[2] = '1'
    ReturnString[2] = '2'
    ReturnString[2] = '3'
    ReturnString[2] = '4'
    ReturnString[2] = '5'
    ReturnString[2] = '6'
    ReturnString[2] = '7'
    ReturnString[2] = '8'
    ReturnString[2] = '9'
    ReturnString[2] = 'A'
    ReturnString[2] = 'B'
    ReturnString[2] = 'C'
    ReturnString[2] = 'D'
    ReturnString[2] = 'E'
    ReturnString[2] = 'F'
  END
  RETURN ReturnString

!=======================================================================================================================
! xLenStr              PROCEDURE(STRING Line), LONG           
!=======================================================================================================================
xLenStr                PROCEDURE(STRING Line)
LOC:CStr               &CSTRING
LOC:Len                LONG

  CODE
  LOC:CStr &= NEW(CSTRING(LEN(Line)))
  LOC:CStr = Line
  LOC:Len = LEN(CLIP(LOC:CStr))
  DISPOSE(LOC:CStr)
  RETURN LOC:Len

!=======================================================================================================================
! xMessage           PROCEDURE(STRING MessageText, <STRING Caption>,       |   MESSAGE
!                             <STRING DisplayIcon>,                        |
!                             <STRING Buttons>, UNSIGNED DefaultButton=0,  |
!                              BOOL Style=FALSE),UNSIGNED,PROC
!=======================================================================================================================
xMessage             PROCEDURE(STRING MessageText, <STRING Caption>,       |
                              <STRING DisplayIcon>, <STRING Buttons>,      |
                               UNSIGNED DefaultButton=0, BOOL Style=FALSE)

St                   STRING(600),AUTO
LineCount            BYTE,AUTO
CPos1                LONG(1)
CPos2a               LONG,AUTO
CPos2b               LONG,AUTO
CPos2                LONG,AUTO
Width1               LONG,AUTO
Width2               LONG
StrHeight            LONG,AUTO
IconOffset           BYTE,AUTO
ControlNo            LONG
SelectedControlNo    LONG
TotalStrings         LONG,AUTO
TotalButtons         LONG,AUTO
ButtonCount          LONG,AUTO
ButtonsVal           LONG,AUTO
ButtonType           LONG,AUTO
ButtonX              LONG,AUTO
CustomButtons        STRING(20),DIM(8)
ButtonResults        LONG,DIM(8)
Result               LONG
BUTTON:Custom        EQUATE(-1)
LastFiledNum         LONG,AUTO

_MaxLineLen          EQUATE(80)

_ButtonHeight        EQUATE(16)
_ButtonWidth         EQUATE(50)
_ButtonOffset        EQUATE(4)
_IconSize            EQUATE(24)

ButtonArray          LONG(0),DIM(8)
ButtonCode           BYTE(1)
StringArray          LONG(0),DIM(20)
StringCode           BYTE(1)

MsgWin WINDOW('<32>'),AT(,,192,71),FONT('MS Sans Serif',8,,),GRAY,DOUBLE
       STRING(''),USE(?String1),HIDE
       STRING(''),USE(?String2),HIDE
       STRING(''),USE(?String3),HIDE
       STRING(''),USE(?String4),HIDE
       STRING(''),USE(?String5),HIDE
       STRING(''),USE(?String6),HIDE
       STRING(''),USE(?String7),HIDE
       STRING(''),USE(?String8),HIDE
       STRING(''),USE(?String9),HIDE
       STRING(''),USE(?String10),HIDE
       STRING(''),USE(?String11),HIDE
       STRING(''),USE(?String12),HIDE
       STRING(''),USE(?String13),HIDE
       STRING(''),USE(?String14),HIDE
       STRING(''),USE(?String15),HIDE
       STRING(''),USE(?String16),HIDE
       STRING(''),USE(?String17),HIDE
       STRING(''),USE(?String18),HIDE
       STRING(''),USE(?String19),HIDE
       STRING(''),USE(?String20),HIDE
       IMAGE,USE(?Image1),HIDE
       BUTTON,USE(?Button1),HIDE
       BUTTON,USE(?Button2),HIDE
       BUTTON,USE(?Button3),HIDE
       BUTTON,USE(?Button4),HIDE
       BUTTON,USE(?Button5),HIDE
       BUTTON,USE(?Button6),HIDE
       BUTTON,USE(?Button7),HIDE
       BUTTON,USE(?Button8),HIDE
     END
  CODE
  OPEN(MsgWin)
  DO InitControls
  LOOP
    CPos2a = INSTRING('<10>', MessageText, 1, CPos1)
    CPos2b = INSTRING('|', MessageText, 1, CPos1)
    IF CPos2a AND CPos2b
      IF CPos2a < CPos2b
        CPos2 = CPos2a
      ELSE
        CPos2 = CPos2b
      END
    ELSIF CPos2a
      CPos2 = CPos2a
    ELSE
      CPos2 = CPos2b
    END
    IF CPos2
      DO CheckLineLen
      DO AddStringControl
      IF MessageText[CPos2-1] = '<13>'
        ControlNo{PROP:Text} = MessageText[CPos1 : CPos2-2]
      ELSE
        ControlNo{PROP:Text} = MessageText[CPos1 : CPos2-1]
      END
      DO CheckControlWidth
    ELSIF LEN(MessageText) >= CPos1
      CPos2 = LEN(CLIP(MessageText))
      DO CheckLineLen
      DO AddStringControl
      ControlNo{PROP:Text} = MessageText[CPos1 : CPos2]
      DO CheckControlWidth
      BREAK
    END
    CPos1 = CPos2 + 1
    IF ~CPos2 THEN BREAK.
  END !LOOP

  IF Caption THEN MsgWin{PROP:Text} = Caption END

  IF DisplayIcon
    IconOffset = _IconSize + 12
  ELSE
    IconOffset = 0
  END

  IF (Width2 + 24 + IconOffset) > MsgWin{PROP:Width}
    MsgWin{PROP:Width} = Width2 + 24 + IconOffset
  END

  TotalStrings = 0
  LOOP ControlNo = 1 TO LASTFIELD()
    IF ControlNo{PROP:Type} = CREATE:String AND ControlNo{PROP:Text} <> ''
      IF ControlNo = 1 THEN StrHeight = ControlNo{PROP:Height}.
      ControlNo{PROP:XPos} = 12 + IconOffset
      ControlNo{PROP:YPos} = 12 + (ControlNo-1)*StrHeight
      ControlNo{PROP:Hide} = 0
      TotalStrings += 1
    END
  END

  IF DisplayIcon
    ControlNo = ?Image1
    ControlNo{PROP:XPos}   = 12
    ControlNo{PROP:YPos}   = 12
    ControlNo{PROP:Width}  = _IconSize
    ControlNo{PROP:Height} = _IconSize
    ControlNo{PROP:Text}   = DisplayIcon
    ControlNo{PROP:Hide}   = 0
  END
  LastFiledNum += 1                                     !  

  !count buttons for sizing
  !in the case of a string list of buttons, also parse the list
  ButtonCount  = 0
  TotalButtons = 0
  IF ~Buttons OR (Buttons = '0')
    ButtonsVal   = BUTTON:OK
    TotalButtons = 1
  ELSIF NUMERIC(Buttons)
    ButtonsVal  = Buttons
    IF ButtonsVal
      IF BAND(ButtonsVal, BUTTON:OK    ) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:YES   ) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:NO    ) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:ABORT ) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:RETRY ) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:IGNORE) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:CANCEL) THEN TotalButtons += 1 END
      IF BAND(ButtonsVal, BUTTON:HELP  ) THEN TotalButtons += 1 END
    END
  ELSE
    TotalButtons = 0
    ButtonsVal   = 0
    CPos1 = 1
    LOOP
      CPos2 = INSTRING('|', Buttons, 1, CPos1)
      IF CPos2
        TotalButtons += 1
        CustomButtons[TotalButtons] = Buttons[CPos1 : CPos2-1]
        CPos1 = CPos2 + 1
      END
      IF TotalButtons = 8 THEN BREAK.
      IF ~CPos2
        !get remainder of string (last button)
        CPos2 = LEN(Buttons)
        TotalButtons += 1
        CustomButtons[TotalButtons] = Buttons[CPos1 : CPos2]
        BREAK
      END
    END
  END

  !determine minimum window width to handle buttons
  Width2 = (TotalButtons * _ButtonWidth) + |    !width of buttons
           ((TotalButtons + 1) * _ButtonOffset) !spacing between and around them

  !make sure window is wide enough for buttons
  IF Width2 > MsgWin{PROP:Width} - 24
    MsgWin{PROP:Width} = Width2 + 24
  END

  !determine width from start of first to end of last button
  Width2 = (TotalButtons * _ButtonWidth) + |    !width of buttons
           ((TotalButtons - 1) * _ButtonOffset) !spacing between and around them
  ButtonX = (MsgWin{PROP:Width} - Width2) / 2

  IF ButtonsVal
    IF BAND(ButtonsVal, BUTTON:OK)
      ButtonType = BUTTON:OK
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:YES)
      ButtonType = BUTTON:YES
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:NO)
      ButtonType = BUTTON:NO
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:ABORT)
      ButtonType = BUTTON:ABORT
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:RETRY)
      ButtonType = BUTTON:RETRY
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:IGNORE)
      ButtonType = BUTTON:IGNORE
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:CANCEL)
      ButtonType = BUTTON:CANCEL
      DO AddButton
    END
    IF BAND(ButtonsVal, BUTTON:HELP)
      ButtonType = BUTTON:HELP
      DO AddButton
    END
  ELSE
    LOOP I# = 1 TO TotalButtons
      ButtonType = BUTTON:Custom
      DO AddButton
    END
  END

  MsgWin{PROP:Height} = ControlNo{PROP:YPos} + ControlNo{PROP:Height} + 8
  MsgWin{PROP:Center}    = 1

  IF Style THEN MsgWin{PROP:Modal} = 1.  !since property is read-only, this doesn't work

  MsgWin{PROP:Alrt, 1} = EscKey

  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF SelectedControlNo
        SELECT(SelectedControlNo)
      END
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF UpKey
      OROF LeftKey
        SELECT(?-1)
      OF DownKey
      OROF RightKey
        SELECT(?+1)
      OF EscKey
        CYCLE
      END
    OF EVENT:Accepted
      !the value inside the brackets is the button count from left;
      !the result is stored in that array element
      Result = ButtonResults[FIELD()-21]
!      MESSAGE('Button: ' & FIELD()-21 & '<13,10>' & |
!              'Code  : ' & Result)
      BREAK
    END !CASE
  END !ACCEPT
  CLOSE(MsgWin)
  RETURN(Result)

InitControls                ROUTINE

  LastFiledNum   = 0

  ButtonArray[1]  = ?Button1
  ButtonArray[2]  = ?Button2
  ButtonArray[3]  = ?Button3
  ButtonArray[4]  = ?Button4
  ButtonArray[5]  = ?Button5
  ButtonArray[6]  = ?Button6
  ButtonArray[7]  = ?Button7
  ButtonArray[8]  = ?Button8

  StringArray[1]  = ?String1
  StringArray[2]  = ?String2
  StringArray[3]  = ?String3
  StringArray[4]  = ?String4
  StringArray[5]  = ?String5
  StringArray[6]  = ?String6
  StringArray[7]  = ?String7
  StringArray[8]  = ?String8
  StringArray[9]  = ?String9
  StringArray[10] = ?String10
  StringArray[11] = ?String11
  StringArray[12] = ?String12
  StringArray[13] = ?String13
  StringArray[14] = ?String14
  StringArray[15] = ?String15
  StringArray[16] = ?String16
  StringArray[17] = ?String17
  StringArray[18] = ?String18
  StringArray[19] = ?String19
  StringArray[20] = ?String20
CheckLineLen        ROUTINE
  !be sure that line we are ready to add doesn't exceed maximum width;
  !if so, then split it up
  DATA
StrPos   LONG,AUTO
Found    BYTE,AUTO
  CODE
  LOOP
    Found = FALSE
    IF (CPos2 - CPos1) > _MaxLineLen
      StrPos = CPos1 + _MaxLineLen
      LOOP
        StrPos -= 1
        IF StrPos = CPos1 THEN BREAK.
        !loop starting from max acceptable position from start of line
        !looking for a space
        IF (MessageText[StrPos] = ' ') OR (MessageText[StrPos] = '-')
          Found = TRUE
          BREAK
        END
      END !LOOP
      IF Found
        !add a string control
        DO AddStringControl
        ControlNo{PROP:Text} = MessageText[CPos1 : StrPos]
        CPos1 = StrPos + 1
        DO CheckControlWidth
      END !IF
    END !IF
    IF ~Found THEN BREAK.
  END !LOOP
CheckControlWidth ROUTINE
  Width1 = ControlNo{PROP:Width}
  IF Width1 > Width2 THEN Width2 = Width1.
AddButton               ROUTINE

  ButtonCount += 1
  ButtonResults[ButtonCount] = ButtonType

  ControlNo = ButtonArray[ButtonCode]
  ButtonCode += 1
  LastFiledNum += 1

  CASE GLO:Language
  OF LANG:Rus
    CASE ButtonType
    OF BUTTON:Custom
      ControlNo{PROP:Text}   = CustomButtons[ButtonCount]
      ButtonResults[ButtonCount] = ButtonCount
    OF BUTTON:OK
      ControlNo{PROP:Text}   = '&OK'
    OF BUTTON:YES
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:NO
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:ABORT
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:RETRY
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:IGNORE
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:CANCEL
      ControlNo{PROP:Text}   = '&'
    OF BUTTON:HELP
      ControlNo{PROP:Text}   = '&'
    END
  OF LANG:Eng
    CASE ButtonType
    OF BUTTON:Custom
      ControlNo{PROP:Text}   = CustomButtons[ButtonCount]
      ButtonResults[ButtonCount] = ButtonCount
    OF BUTTON:OK
      ControlNo{PROP:Text}   = '&OK'
    OF BUTTON:YES
      ControlNo{PROP:Text}   = '&Yes'
    OF BUTTON:NO
      ControlNo{PROP:Text}   = '&No'
    OF BUTTON:ABORT
      ControlNo{PROP:Text}   = '&Cancel'
    OF BUTTON:RETRY
      ControlNo{PROP:Text}   = '&Retry'
    OF BUTTON:IGNORE
      ControlNo{PROP:Text}   = '&Ignore'
    OF BUTTON:CANCEL
      ControlNo{PROP:Text}   = '&Abort'
    OF BUTTON:HELP
      ControlNo{PROP:Text}   = '&Help'
    END
  END

  ControlNo{PROP:Left}     = TRUE
  ControlNo{PROP:Flat}     = FALSE
  ControlNo{PROP:Width}    = _ButtonWidth
  ControlNo{PROP:Height}   = _ButtonHeight

  ControlNo{PROP:XPos}     = ButtonX          !set position
  ButtonX += (_ButtonWidth + _ButtonOffset)   !and set next buttons position

  ControlNo{PROP:YPos}     = TotalStrings * StrHeight + 18
  IF DisplayIcon AND (ControlNo{PROP:YPos} < _IconSize + 24)
    ControlNo{PROP:YPos}   = _IconSize + 24
  END

  IF ButtonCount > 1
    ControlNo{PROP:Alrt,1} = LeftKey
    ControlNo{PROP:Alrt,2} = UpKey
    IF ButtonCount < TotalButtons
      ControlNo{PROP:Alrt,3} = RightKey
      ControlNo{PROP:Alrt,4} = DownKey
    END
  ELSIF TotalButtons > 1
    ControlNo{PROP:Alrt,1} = RightKey
    ControlNo{PROP:Alrt,2} = DownKey
  END

  IF ((ButtonType = BUTTON:Custom) AND (DefaultButton = ButtonCount)) OR |
     (DefaultButton = ButtonType)                                     OR |
     (~DefaultButton AND (ButtonCount = 1))
    Result = ButtonResults[ButtonCount]
    SelectedControlNo = ControlNo
  END

  ControlNo{PROP:Hide} = 0

AddStringControl        ROUTINE
  ControlNo = StringArray[StringCode]
  StringCode += 1
  LastFiledNum += 1


!=======================================================================================================================
! xWarning           PROCEDURE(STRING WarningMessage, <BYTE MessageType>), BYTE, PROC     
!=======================================================================================================================
xWarning             PROCEDURE(STRING WarningMessage, <BYTE MessageType>)

  CODE
  IF OMITTED(2) OR MessageType = 0
    MessageType = 1
  END
  CASE GLO:Language
  OF LANG:Rus
    CASE MessageType
    OF 1
      MESSAGE(WarningMessage, '', ICON:Asterisk, BUTTON:Ok, BUTTON:Ok, 1)
    OF 2
      RETURN MESSAGE(WarningMessage, '', ICON:Question, BUTTON:Yes+BUTTON:No, BUTTON:Yes, 1)
    OF 3
      MESSAGE(WarningMessage, '', ICON:Exclamation, BUTTON:Ok, BUTTON:Ok, 1)
    END
  OF LANG:Eng
    CASE MessageType
    OF 1
      MESSAGE(WarningMessage, 'Warning', ICON:Asterisk, BUTTON:Ok, BUTTON:Ok, 1)
    OF 2
      RETURN MESSAGE(WarningMessage, 'Warning', ICON:Question, BUTTON:Yes+BUTTON:No, BUTTON:Yes, 1)
    OF 3
      MESSAGE(WarningMessage, 'Warning', ICON:Exclamation, BUTTON:Ok, BUTTON:Ok, 1)
    END
  END

!==========================================================================================================================
! Debug function
!==========================================================================================================================
! xDebug               PROCEDURE(STRING Messages)
!==========================================================================================================================
xDebug                 PROCEDURE(STRING Messages)

  CODE
  TEMP:MY:FILE:Name = 'DEBUG.TXT'
  OPEN(TEMP:MY:FILE)
  IF ERRORCODE()
    CREATE(TEMP:MY:FILE)
    OPEN(TEMP:MY:FILE)
    IF ERRORCODE()
      xWarning(ERROR())
      RETURN
    END
  END
  TMF:Line = Messages
  ADD(TEMP:MY:FILE)
  IF ERRORCODE() THEN xWarning(ERROR()) END
  CLOSE(TEMP:MY:FILE)

!==========================================================================================================================
! xDebugEvent          PROCEDURE(LONG EventParam)
!==========================================================================================================================
xDebugEvent            PROCEDURE(LONG EventParam)

  CODE
  CASE EventParam
  OF 01H
    xDebug('EVENT:Accepted      ')
  OF 02H
    xDebug('EVENT:NewSelection  ')
  OF 03H
    xDebug('EVENT:ScrollUp      ')
  OF 04H
    xDebug('EVENT:ScrollDown    ')
  OF 05H
    xDebug('EVENT:PageUp        ')
  OF 06H
    xDebug('EVENT:PageDown      ')
  OF 07H
    xDebug('EVENT:ScrollTop     ')
  OF 08H
    xDebug('EVENT:ScrollBottom  ')
  OF 09H
    xDebug('EVENT:Locate        ')
  OF 01H
    xDebug('EVENT:MouseDown     ')
  OF 0aH
    xDebug('EVENT:MouseUp       ')
  OF 0bH
    xDebug('EVENT:MouseIn       ')
  OF 0cH
    xDebug('EVENT:MouseOut      ')
  OF 0dH
    xDebug('EVENT:MouseMove     ')
  OF 0eH
    xDebug('EVENT:VBXevent      ')
  OF 0fH
    xDebug('EVENT:AlertKey      ')
  OF 10H
    xDebug('EVENT:PreAlertKey   ')
  OF 11H
    xDebug('EVENT:Dragging      ')
  OF 12H
    xDebug('EVENT:Drag          ')
  OF 13H
    xDebug('EVENT:Drop          ')
  OF 14H
    xDebug('EVENT:ScrollDrag    ')
  OF 15H
    xDebug('EVENT:TabChanging   ')
  OF 16H
    xDebug('EVENT:Expanding     ')
  OF 17H
    xDebug('EVENT:Contracting   ')
  OF 18H
    xDebug('EVENT:Expanded      ')
  OF 19H
    xDebug('EVENT:Contracted    ')
  OF 1AH
    xDebug('EVENT:Rejected      ')
  OF 1BH
    xDebug('EVENT:DroppingDown  ')
  OF 1CH
    xDebug('EVENT:DroppedDown   ')
  OF 1DH
    xDebug('EVENT:ScrollTrack   ')
  OF 1EH
    xDebug('EVENT:ColumnResize  ')
  OF 1FH
    xDebug('EVENT:Selecting     ')
  OF 101H
    xDebug('EVENT:Selected      ')
  OF 201H
    xDebug('EVENT:CloseWindow   ')
  OF 202H
    xDebug('EVENT:CloseDown     ')
  OF 203H
    xDebug('EVENT:OpenWindow    ')
  OF 204H
    xDebug('EVENT:OpenFailed    ')
  OF 205H
    xDebug('EVENT:LoseFocus     ')
  OF 206H
    xDebug('EVENT:GainFocus     ')
  OF 208H
    xDebug('EVENT:Suspend       ')
  OF 209H
    xDebug('EVENT:Resume        ')
  OF 20BH
    xDebug('EVENT:Timer         ')
  OF 20CH
    xDebug('EVENT:DDErequest    ')
  OF 20DH
    xDebug('EVENT:DDEadvise     ')
  OF 20EH
    xDebug('EVENT:DDEdata       ')
  OF 20FH
    xDebug('EVENT:DDEcommand    ')
  OF 20FH
    xDebug('EVENT:DDEexecute    ')
  OF 210H
    xDebug('EVENT:DDEpoke       ')
  OF 211H
    xDebug('EVENT:DDEclosed     ')
  OF 220H
    xDebug('EVENT:Move          ')
  OF 221H
    xDebug('EVENT:Size          ')
  OF 222H
    xDebug('EVENT:Restore       ')
  OF 223H
    xDebug('EVENT:Maximize      ')
  OF 224H
    xDebug('EVENT:Iconize       ')
  OF 225H
    xDebug('EVENT:Completed     ')
  OF 230H
    xDebug('EVENT:Moved         ')
  OF 231H
    xDebug('EVENT:Sized         ')
  OF 232H
    xDebug('EVENT:Restored      ')
  OF 233H
    xDebug('EVENT:Maximized     ')
  OF 234H
    xDebug('EVENT:Iconized      ')
  OF 235H
    xDebug('EVENT:Docked        ')
  OF 236H
    xDebug('EVENT:Undocked      ')
  OF 240H
    xDebug('EVENT:BuildFile     ')
  OF 241H
    xDebug('EVENT:BuildKey      ')
  OF 242H
    xDebug('EVENT:BuildDone     ')
  OF 400H
    xDebug('EVENT:User          ')
  OF 0FFFH
    xDebug('EVENT:Last          ')
  ELSE
    xDebug('UNREGISTERED EVENT()')
  END

!==========================================================================================================================
! Work with Clarion EMBED editor
!==========================================================================================================================
! xPasteToEditor       PROCEDURE(LONG WinHandle, <STRING StrToEditor>)
!==========================================================================================================================
xPasteToEditor         PROCEDURE(LONG WinHandle, <STRING StrToEditor>)

  CODE
  IF NOT OMITTED(2)
    SETCLIPBOARD(StrToEditor)
  END
  Err# = xf_BringWindowToTop(WinHandle)
  !  CTRL+V
  xf_keybd_event(VK_CONTROL, 0, 0, 0)
  xf_keybd_event(VKey,       0, 0, 0)
  xf_keybd_event(VKey,       0, KEYEVENTF_KEYUP, 0)
  xf_keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)

!==========================================================================================================================
! xCopyFromEditor       PROCEDURE(LONG WinHandle)
!==========================================================================================================================
xCopyFromEditor         PROCEDURE(LONG WinHandle)
  CODE
  Err# = xf_BringWindowToTop(WinHandle)
  !  CTRL+C
  xf_keybd_event(VK_CONTROL, 0, 0, 0)
  xf_keybd_event(CKey,       0, 0, 0)
  xf_keybd_event(CKey,       0, KEYEVENTF_KEYUP, 0)
  xf_keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)

!==========================================================================================================================
! Other
!==========================================================================================================================
! xGetMemorySize        PROCEDURE(BYTE MemType), REAL
!==========================================================================================================================
xGetMemorySize          PROCEDURE(BYTE MemType)

xMEM_STATUS        GROUP,PRE(xMEM)
dwLength             LONG
dwMemoryLoad         LONG
dwTotalPhys          LONG
dwAvailPhys          LONG
dwTotalPageFile      LONG
dwAvailPageFile      LONG
dwTotalVirtual       LONG
dwAvailVirtual       LONG
                   END

xInfoAddress       LONG
xMemorySize        CSTRING(256)

  CODE
  xMemorySize   = ''
  xInfoAddress  = ADDRESS(xMEM_Status)
  xMEM:dwLength = 32
  xf_GlobalMemoryStatus(xInfoAddress)
  EXECUTE MemType
    xMemorySize = xMEM:dwTotalPhys
    xMemorySize = xMEM:dwAvailPhys
    xMemorySize = xMEM:dwTotalVirtual
    xMemorySize = xMEM:dwAvailVirtual
  END
  RETURN xMemorySize
!==========================================================================================================================
! xGetClentRectSize     PROCEDURE(WINDOW Window, *LONG Width, *LONG Height)
!==========================================================================================================================
xGetClentRectSize       PROCEDURE(WINDOW Window, *LONG Width, *LONG Height)
cRect                   LIKE(XFRect)
  CODE
  xf_GetClientRect(Window{PROP:ClientHandle}, cRect)
  Width  = cRect.Right  - ((xf_GetSystemMetrics(xf_SM_CYFIXEDFRAME)*2)+(xf_GetSystemMetrics(xf_SM_CYBORDER)*2))
  Height = cRect.Bottom - ((xf_GetSystemMetrics(xf_SM_CXFIXEDFRAME)*2)+(xf_GetSystemMetrics(xf_SM_CXBORDER)*2)+xf_GetSystemMetrics(xf_SM_CYMENUSIZE))
!==========================================================================================================================
! Network
!==========================================================================================================================
! xNetDialog            PROCEDURE(<STRING inTitle>)!,STRING,PROC
!==========================================================================================================================
xNetDialog              PROCEDURE(<STRING inTitle>)!,STRING,PROC
BI                      LIKE(xf_BROWSE_INFO_TYPE)
loc:DisplayName         CSTRING(260)
loc:Title               CSTRING(260)
loc:ItemID              LONG
loc:StartFold           LONG
loc:CompName            STRING(260)
  CODE
  IF OMITTED(1)
    loc:Title=''
  ELSE
    loc:Title=clip(inTitle)
  END

  IF xf_SHGetSpecialFolderLocation(0{Prop:Handle},xf_CSIDL_NETWORK,loc:StartFold)
    loc:StartFold = 0 ! if error
  END

  CLEAR(BI)
  BI.hwndOwner      = 0{Prop:Handle}
  BI.pidlRoot       = loc:StartFold
  BI.pszDisplayName = ADDRESS(loc:DisplayName)
  BI.lpszTitle      = ADDRESS(loc:Title)
  BI.ulFlags        = xf_BIF_BROWSEFORCOMPUTER

  loc:ItemID = xf_SHBrowseForFolder(ADDRESS(BI))
  IF loc:ItemID
    IF xf_SHGetPathFromIDList(loc:ItemID, ADDRESS(loc:Path))
      loc:CompName = loc:Path
    ELSE
      loc:CompName = loc:DisplayName
    END
  END
  RETURN loc:CompName

!==========================================================================================================================
! Classes
!==========================================================================================================================
xLabelClass.Init        PROCEDURE(LONG Feq, LONG Color=0,<STRING Text>)
  CODE
  SELF.Feq   = Feq
  SELF.Color = Color
  SELF.Text  = Text
xLabelClass.Show        PROCEDURE(*? Text)
  CODE
  IF CLIP(SELF.Text) <> ''
    (SELF.Feq){PROP:Text} = CLIP(SELF.Text) & ' ' & Text
    DO SetColor
  ELSE
    (SELF.Feq){PROP:Text} = Text
    DO SetColor
  END
  DISPLAY(SELF.Feq)
!------------------------------------------------------------------------------------
SetColor                ROUTINE
  IF NUMERIC(Text)
    IF Text <= 0
      SETFONT(SELF.Feq,,,SELF.Color)
    ELSE
      SETFONT(SELF.Feq,,,COLOR:Black)
    END
  ELSE
    SETFONT(SELF.Feq,,,COLOR:Black)
  END
!==========================================================================================================================
! END of xFunction Library
!==========================================================================================================================
