#TEMPLATE(xFunction,'xFunction Library v2.8'), FAMILY('ABC'), FAMILY('CLARION'), FAMILY('CW20')
#!====================================================================================================================
#!
#!====================================================================================================================
#EXTENSION(xFunction,'Global support for xFunction Library v2.8'),APPLICATION
#SHEET
  #TAB('General')
    #IMAGE('sealsoft.bmp')
    #DISPLAY('xFunction Library'),AT(85,20),PROP(PROP:FontStyle,700)
    #DISPLAY('Version 2.8'),AT(85,30),PROP(PROP:FontStyle,700)
    #DISPLAY('Copyright 2001-2010'),AT(85,40),PROP(PROP:FontStyle,700)
    #DISPLAY('SealSoft Company'),AT(85,50),PROP(PROP:FontStyle,700)
    #DISPLAY('All Rights Reserved'),AT(85,60),PROP(PROP:FontStyle,700)
    #DISPLAY
    #DISPLAY
    #DISPLAY('WARNING')
    #DISPLAY('This product is protected by copyright and international')
    #DISPLAY('law. Unauthorized reproduction and/or distribution of this')
    #DISPLAY('product may result in severe civil and criminal penalties,')
    #DISPLAY('and will be prosecuted to the maximum extend possible')
    #DISPLAY('under the law.')
    #DISPLAY
    #PROMPT('Support E-Mail:',@S200),%CompanyMail,DEFAULT('support@seal-soft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
    #PROMPT('Official Site:',@S200),%CompanySite,DEFAULT('http://www.seal-soft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
    #DISPLAY()
  #ENDTAB
  #TAB('Settings')
    #PROMPT('Don''t export function list',CHECK),%DontExport,AT(10)
    #PROMPT('Include version.lib to project',CHECK),%IncludeVerLib,DEFAULT(%TRUE),AT(10)
  #ENDTAB
#ENDSHEET
#!====================================================================================================================
#AT(%DLLExportList)
  #IF(~%GlobalExternal AND (%ProgramExtension = 'DLL') AND %DontExport = %FALSE)
  XGETUNIQCODE@FBFBKRL                                    @?
  XAGECALCULATE@FL                                        @?
  XNORMDIR@FSB                                            @?
  XPATHEXISTS@FSB                                         @?
  XCREATEDIR@FSB                                          @?
  XFINDFILE@FSB                                           @?
  XDENORMDIR@FSB                                          @?
  XGETFILEATTR@FSBL                                       @?
  XSETFILEATTR@FSBL                                       @?
  XEXTRACTFILE@FSB                                        @?
  XEXTRACTEXT@FSB                                         @?
  XEXTRACTPATH@FSB                                        @?
  XEXTRACTFILENAME@FSB                                    @?
  XWARNING@FSBOUC                                         @?
  XREMOVEPATHFROMFILENAME@FRSBRSB                         @?
  XSETLANGUAGE@FUC                                        @?
  XLENSTR@FSB                                             @?
  XHEX@FUc                                                @?
  XCHECKFORSUBFOLDERS@Fsb                                 @?
  XDELAY@FUl                                              @?
  XGETDAYNAME@FOlOUc                                      @?
  XGETDAYNUMBER@FOl                                       @?
  XOPENFOLDER@Fsb                                         @?
  XGETCONFIG@FBf                                          @?
  XPUTCONFIG@FBf                                          @?
  XWEEKOFYEAR@FOl                                         @?
  XWEEKOFMONTH@FOl                                        @?
  XQUARTOFYEAR@FOl                                        @?
  XMONTHOFYEAR@FOlOUc                                     @?
  XLEAPYEAR@FOl                                           @?
  XCREATETREEDIR@Fsb                                      @?
  XDELETEFILE@Fsb                                         @?
  XCOPYFILE@Fsbsb                                         @?
  XMOVEFILE@Fsbsb                                         @?
  XPASTETOEDITOR@FlOsb                                    @?
  XCOPYFROMEDITOR@Fl                                      @?
  XGENGLOBALID@F                                          @?
  XDEBUG@Fsb                                              @?
  XDEBUGEVENT@Fl                                          @?
  XGETMEMORYSIZE@FUc                                      @?
  XSETENGMONTH@FUcsb                                      @?
  XSETENGDAY@FUcsb                                        @?
  XGETDRIVERS@F12DRIVERSQUEUE                             @?
  XINITLIBRARY@F                                          @?
  XISLASTDAYOFMONTH@FOl                                   @?
  XLASTDAYOFMONTH@FOl                                     @?
  XDAYOFYEAR@FOl                                          @?
  XDAYSLEFTINYEAR@FOl                                     @?
  XSETPERIODCURRWEEK@FRlRl                                @?
  XSETPERIODLASTWEEK@FRlRl                                @?
  XSETPERIODNEXTWEEK@FRlRl                                @?
  XSETPERIODLASTMONTH@FRlRl                               @?
  XSETPERIODCURRMONTH@FRlRl                               @?
  XSETPERIODNEXTMONTH@FRlRl                               @?
  XSETPERIODLASTQUART@FRlRl                               @?
  XSETPERIODCURRQUART@FRlRl                               @?
  XSETPERIODNEXTQUART@FRlRl                               @?
  XGETZODIAC@FLRsb                                        @?
  XGETCHINEYEAR@FLRsb                                     @?
  XSETRUSZODIAC@FUcsb                                     @?
  XSETENGZODIAC@FUcsb                                     @?
  XSETRUSCHINEYEAR@FUcsb                                  @?
  XSETENGCHINEYEAR@FUcsb                                  @?
  XGETRELATIVEPATH@FSB                                    @?
  XGETFILEVERSION@FSB                                     @?
  XGETFILESIZE@FSB                                        @?
  XNETDIALOG@FOSB                                         @?
  XGETCLENTRECTSIZE@FBwRlRl                               @?
  XREPLACE@FRsbsbsb                                       @?
  XQUOTE@Fsb                                              @?
  XGETTEMPPATH@F                                          @?
  XGETFILEDATE@FsbRlRl                                    @?
  #INSERT(%AddExpPrototype,'xReplace(*CSTRING Into, STRING Find, STRING Replace)')
  #ENDIF
#ENDAT
#!====================================================================================================================
#AT(%BeforeGlobalIncludes)
   INCLUDE('xfunc.inc','CONSTANTS'),ONCE
   INCLUDE('xfunc.inc','CLASSES'),ONCE
#ENDAT
#!====================================================================================================================
#AT(%GlobalMap)
  MODULE('xFunction ver 2.8')
    INCLUDE('xfunc.inc','PROTOTYPES'),ONCE
  END
#ENDAT
#!====================================================================================================================
#AT(%CustomGlobalDeclarations)
  #FIX (%Driver, 'ASCII')
  #PROJECT (%DriverLIB)
  #IF(%IncludeVerLib)
    #PROJECT('version.lib')
  #ENDIF
#IF(~%GlobalExternal)
  #PROJECT('xfunc.clw')
#ENDIF
#ENDAT
#!====================================================================================================================
#GROUP(%AddExpPrototype,%ItemPrototype,%pLegacy=0)
#! Group added by Spectrum Lab, May 2010
  #IF(%pLegacy AND %CWTemplateVersion <= 'v6.0')
    #SET(%ExpLineNumber,%ExpLineNumber + 1)
%[55](LINKNAME(%ItemPrototype)) @%ExpLineNumber
  #ELSE
%[55](LINKNAME(%ItemPrototype)) @?
  #ENDIF
#!====================================================================================================================
