   PROGRAM


   INCLUDE('xfunc.inc','CONSTANTS'),ONCE
FA_NORMAL            EQUATE(00h)
FA_RDONLY            EQUATE(01h)
FA_HIDDEN            EQUATE(02h)
FA_SYSTEM            EQUATE(04h)
FA_LABEL             EQUATE(08h)
FA_DIREC             EQUATE(10h)
FA_ARCH              EQUATE(20h)



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('xToolTip.inc'),ONCE
   INCLUDE('xtiphotkey.inc'),ONCE

   MAP
     MODULE('XFC60BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('XFC60001.CLW')
Main                   PROCEDURE   !
     END
       MODULE('xFunction ver 2.2')
         INCLUDE('xfunc.inc','PROTOTYPES'),ONCE
       END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'


xToolTip             xToolTipClass

GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  INIMgr.Init('.\xFunc.ini', NVD_INI)                      ! Configure INIManager to use INI file
  DctInit
  xToolTip.Init(,'xFunction',1)
  Main
  INIMgr.Update
  xToolTip.Kill
  INIMgr.Kill                                              ! Destroy INI manager


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

